
# Exp. 1 between subjects design

# define properties of experiments
n1 = 20 # No prime
n2 = 20 # Professor prime
n3 = 20 # Secretary prime

TestResult = 0

# prime types
Means = c(49.9, 59.5, 46.4)
SDs = sqrt(163.1323877) + 0*c(1:3) # same for all conditions
		
numRepeats = 100000
numSuccess = 0
numSuccessMain = 0
numSuccessPvN = 0
numSuccessPvS = 0

for(rep in c(1:numRepeats)){

# Draw random samples and run the tests, then compute power for those test from that sample
    none  <- rnorm(n1, mean=Means[1], sd=SDs[1])
	profs <- rnorm(n2, mean=Means[2], sd=SDs[2])	
    secs  <- rnorm(n3, mean=Means[3], sd=SDs[3])
	
	Level<- c()
	prop <- c() 
	# Set up for ANOVA
	for(i in c(1:n1)){
		Level<- c(Level, "None")
		prop <- c(prop, none[i])
	}
	for(i in c(1:n2)){
		Level<- c(Level, "Professor")
		prop <- c(prop, profs[i])
	}
	for(i in c(1:n3)){
		Level<- c(Level, "Secretaries")
		prop <- c(prop, secs[i])
	}

	
	dataOneWay=data.frame(Level=Level, prop = prop)
		
	#ANOVA	
	out <- anova(lm(prop ~ Level, dataOneWay))
	thing<-out$`Pr(>F)`
	anovaP = thing[1]
	thing2<-out$`Mean Sq`
	mse = thing2[2]
			
	# t-test contrasts
	se = sqrt(2*mse/n1)
	contrastdf = n1+n2+n3 -3
	
	# Prof vs. none
	L = mean(profs) - mean(none)
	tvalue = L/se
	pvalue1 = 2 * (1- pt(tvalue, df= contrastdf) )
	
	# Prof vs. secretary
	L = mean(profs) - mean(secs)
	tvalue = L/se
	pvalue2 = 2 * (1- pt(tvalue, df= contrastdf) )
	
   		
		# See if all tests rejects as predicted 
			if (anovaP <=0.05 && pvalue1<=0.05 && pvalue2<=0.05)
			{
				numSuccess = numSuccess +1
				}
		# Estimate power for individual effects
		if (anovaP <=0.05)
			{
				numSuccessMain = numSuccessMain +1
				}				
		if (pvalue1 <=0.05)
			{
				numSuccessPvN = numSuccessPvN +1
				}					
			
		if (pvalue2 <=0.05)
			{
				numSuccessPvS = numSuccessPvS +1
				}					
				
}

EstimatedPower = numSuccess/numRepeats

cat("Power for all effects ", EstimatedPower, "\n")

cat("Power for main effect ", numSuccessMain/numRepeats, "\n")
cat("Power for PvN effect ", numSuccessPvN/numRepeats, "\n")
cat("Power for PvS effect ", numSuccessPvS/numRepeats, "\n")
