
# Exp. 3 between subjects design

# define properties of experiments
n1 = 31 # No prime
n2 = 32 # 2 minutes prime (Hooligans)
n3 = 32 # 9 minutes prime (Hooligans)

TestResult = 0

# prime types
Means = c(51.3, 48.6, 43.1)
SDs = sqrt(101.6048485) + 0*c(1:3) # same for all conditions
		
numRepeats = 100000
numSuccess = 0
numSuccessMain = 0
numSuccess9vN = 0
numSuccess9v2 = 0
for(rep in c(1:numRepeats)){

# Draw random samples and run the tests, then compute power for those test from that sample
    none  <- rnorm(n1, mean=Means[1], sd=SDs[1])
	min2 <- rnorm(n2, mean=Means[2], sd=SDs[2])	
    min9  <- rnorm(n3, mean=Means[3], sd=SDs[3])
	
	Level<- c()
	prop <- c() 
	# Set up for ANOVA
	for(i in c(1:n1)){
		Level<- c(Level, "None")
		prop <- c(prop, none[i])
	}
	for(i in c(1:n2)){
		Level<- c(Level, "min2")
		prop <- c(prop, min2[i])
	}
	for(i in c(1:n3)){
		Level<- c(Level, "min9")
		prop <- c(prop, min9[i])
	}

	
	dataOneWay=data.frame(Level=Level, prop = prop)
		
	#ANOVA	
	out <- anova(lm(prop ~ Level, dataOneWay))
	thing<-out$`Pr(>F)`
	anovaP = thing[1]
	thing2<-out$`Mean Sq`
	mse = thing2[2]
			
	# t-test contrasts
	se = sqrt(2*mse/n2)
	contrastdf = n1+n2+n3 -3
	
	# 9 vs. none
	L = abs(mean(min9) - mean(none))
	tvalue = L/se
	pvalue1 = 2 * (1- pt(tvalue, df= contrastdf) )
	
	# 9 vs. 2
	L = abs(mean(min9) - mean(min2))
	tvalue = L/se
	pvalue2 = 2 * (1- pt(tvalue, df= contrastdf) )
	
   		
		# See if all tests rejects as predicted 
			if (anovaP <=0.05 && pvalue1<=0.05 && pvalue2<=0.05)
			{
				numSuccess = numSuccess +1
				}
			
		# Estimate power for individual effects
		if (anovaP <=0.05)
			{
				numSuccessMain = numSuccessMain +1
				}				
		if (pvalue1 <=0.05)
			{
				numSuccess9vN = numSuccess9vN +1
				}					
			
		if (pvalue2 <=0.05)
			{
				numSuccess9v2 = numSuccess9v2 +1
				}					
				
}

EstimatedPower = numSuccess/numRepeats

cat("Power for all effects ", EstimatedPower, "\n")

cat("Power for main effect ", numSuccessMain/numRepeats, "\n")
cat("Power for 9vN effect ", numSuccess9vN/numRepeats, "\n")
cat("Power for 9v2 effect ", numSuccess9v2/numRepeats, "\n")
