# Study 4 between subjects design

# define properties of experiments
n1 = 11 # Int, stereo
n2 = 11 # Int, trait
n3 = 10 # Stupid, Stereo
n4 = 11 # Stupid, trait

TestResult = 0

# conditions
Means = c(55.6, 46.0, 42.5, 37.9)
SDs = sqrt(165.6994382) + 0*c(1:4) # same for all conditions

		
numRepeats = 100000
numSuccess = 0
numSuccessIvS = 0 #(Intelligent vs stupid prime)
numSuccessSvT = 0 # (StereoTarget vs Trait)

for(rep in c(1:numRepeats)){

# Draw random samples and run the tests, then compute power for those test from that sample
    IntStereo  <- rnorm(n1, mean=Means[1], sd=SDs[1])
	IntTrait <- rnorm(n2, mean=Means[2], sd=SDs[2])	
    StupidStereo  <- rnorm(n3, mean=Means[3], sd=SDs[3])
	StupidTrait <- rnorm(n4, mean=Means[4], sd=SDs[4])	
    				
	Prime<- c()
	Target <- c()
	prop <- c()    				
	# Set up for ANOVA
	for(i in c(1:n1)){
		Prime<- c(Prime, "Intelligent")
		Target <- c(Target, "SteroTarget")
		prop <- c(prop, IntStereo[i])
	}
	for(i in c(1:n2)){
		Prime<- c(Prime, "Intelligent")
		Target <- c(Target, "Trait")
		prop <- c(prop, IntTrait[i])
	}
	for(i in c(1:n3)){
		Prime<- c(Prime, "Stupid")
		Target <- c(Target, "SteroTarget")
		prop <- c(prop, StupidStereo[i])
	}
	for(i in c(1:n4)){
		Prime<- c(Prime, "Stupid")
		Target <- c(Target, "Trait")
		prop <- c(prop, StupidTrait[i])
	}
	
	dataTwoWay=data.frame(Prime=Prime,Target=Target, prop=prop)
	
	#ANOVA	
	out <- anova(lm(prop ~ Prime*Target, dataTwoWay))
	thing<-out$`Pr(>F)`
	primeP = thing[1]
	targetP = thing[2]

   		
		# See if all tests rejects as predicted 
			if (primeP <=0.05  && targetP>0.05)	
			{
				numSuccess = numSuccess +1
				}
			
		# Estimate power for individual effects
		if (primeP <=0.05)
			{
				numSuccessIvS = numSuccessIvS +1
				}				
		if (targetP >0.05)
			{
				numSuccessSvT = numSuccessSvT +1
				}					
				
}

EstimatedPower = numSuccess/numRepeats

cat("Power for all effects ", EstimatedPower, "\n")

cat("Power for priming effect ", numSuccessIvS/numRepeats, "\n")
cat("Probability of null finding for stereoTargets vs. traits effect ", numSuccessSvT/numRepeats, "\n")
